function eng = computeF(u, D, epsilon, f)
    Du = D*u;
    ind1 = abs(Du)>=epsilon;
    ind2 = abs(Du)<epsilon;
    Du(ind1) = abs(Du(ind1)) - epsilon/2;
    Du(ind2) = 1/2/epsilon * (Du(ind2)).^2;
    eng = 1/2*norm(u-f)^2 + sum(Du);
end